#delimit;
set more 1;
log using /volumes/ddisk/immigration/programs/chapter_6/aggregate/count_state_m.log, replace;

*CALCULATES FTE'S, COUNTS OF WORKERS, AND POPULATION COUNTS, USING STATE CELLS;

use /volumes/ddisk/ipums5/ipums60.dta, clear;

keep if sex==1;
drop if gq==0 | gq==3 | gq==4; 
drop if age<18 | age>64;
*drop if school==2;

generate byte imm=(bpld>=15000);
replace imm=0 if bpld==90011 | bpld==90021;

generate byte edcode=1*(educd<=50) + 2*(educd>=60 & educd<=64)
	+ 3*(educd>=65 & educd<=90) + 4*(educd==100 | educd==101) + 5*(educd>=110);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate weeks=8.0*(wkswork2==1) + 20.8*(wkswork2==2) + 33.1*(wkswork2==3) 
	+ 42.4*(wkswork2==4) + 48.3*(wkswork2==5) + 51.9*(wkswork2==6) ;
generate hours=8.7*(hrswork2==1) + 20.9*(hrswork2==2) + 31.1*(hrswork2==3) 
	+ 36.5*(hrswork2==4) + 40*(hrswork2==5) + 45.3*(hrswork2==6) 
	+ 51.8*(hrswork2==7) + 68.1*(hrswork2==8) ;
	
generate weight=perwt*weeks*hours/2000;

rename statefip state;
generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf
	(count) size=perwt, 
    by(state edcode expcode);
generate survey=1960;
sort survey state edcode expcode;

save /volumes/ddisk/data/junk60.dta, replace;



use /volumes/ddisk/ipums5/ipums70.dta, clear;

keep if sex==1;
drop if gq==0 | gq==3 | gq==4; 
drop if age<18 | age>64;
replace school=higraded - (int(higraded/10))*10;
*drop if school==2;

keep if datanum==1;
/*
*RESCALE perwt DUE TO 3% SAMPLE;
replace perwt=perwt/3;
*/

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

generate byte edcode=1*(educd<=50) + 2*(educd>=60 & educd<=64)
	+ 3*(educd>=65 & educd<=90) + 4*(educd==100 | educd==101) + 5*(educd>=110);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate weeks=8.0*(wkswork2==1) + 20.8*(wkswork2==2) + 33.1*(wkswork2==3) 
	+ 42.4*(wkswork2==4) + 48.3*(wkswork2==5) + 51.9*(wkswork2==6) ;
generate hours=8.7*(hrswork2==1) + 20.9*(hrswork2==2) + 31.1*(hrswork2==3) 
	+ 36.5*(hrswork2==4) + 40*(hrswork2==5) + 45.3*(hrswork2==6) 
	+ 51.8*(hrswork2==7) + 68.1*(hrswork2==8) ;

generate weight=perwt*weeks*hours/2000;

rename statefip state;
generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf
	(count) size=perwt, 
    by(state edcode expcode);
generate survey=1970;
sort survey state edcode expcode;

save /volumes/ddisk/data/junk70.dta, replace;




use /volumes/ddisk/ipums5/ipums80.dta, clear;

keep if sex==1;
drop if gq==0 | gq==3 | gq==4; 
drop if age<18 | age>64;
*drop if school==2;

generate byte imm=(citizen==2 | citizen==3);

generate byte edcode=1*(educd<=50) + 2*(educd>=60 & educd<=64)
	+ 3*(educd>=65 & educd<=90) + 4*(educd==100 | educd==101) + 5*(educd>=110);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate weeks=wkswork1;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

rename statefip state;
generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf
	(count) size=perwt, 
    by(state edcode expcode);
generate survey=1980;
sort survey state edcode expcode;

save /volumes/ddisk/data/junk80.dta, replace;




use /volumes/ddisk/ipums5/ipums90.dta, clear;

keep if sex==1;
drop if gq==0 | gq==3 | gq==4; 
drop if age<18 | age>64;
*drop if school==2;

generate byte imm=(citizen==2 | citizen==3);

generate byte edcode=1*(educd<=50) + 2*(educd>=60 & educd<=64)
	+ 3*(educd>=65 & educd<=90) + 4*(educd==100 | educd==101) + 5*(educd>=110);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate weeks=wkswork1;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

rename statefip state;
generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf
	(count) size=perwt, 
    by(state edcode expcode);
generate survey=1990;
sort survey state edcode expcode;

save /volumes/ddisk/data/junk90.dta, replace;



use /volumes/ddisk/ipums5/ipums00.dta, clear;

keep if sex==1;
drop if gq==0 | gq==3 | gq==4; 
drop if age<18 | age>64;
*drop if school==2;

generate byte imm=(citizen==2 | citizen==3);

generate byte edcode=1*(educd<=50) + 2*(educd>=60 & educd<=64)
	+ 3*(educd>=65 & educd<=90) + 4*(educd==100 | educd==101) + 5*(educd>=110);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate weeks=wkswork1;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

rename statefip state;
generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf
	(count) size=perwt, 
    by(state edcode expcode);
generate survey=2000;
sort survey state edcode expcode;

save /volumes/ddisk/data/junk00.dta, replace;


use /volumes/ddisk/ipums5/acs0711.dta, clear;

keep if sex==1;
drop if gq==0 | gq==3 | gq==4; 
drop if age<18 | age>64;
*drop if school==2;

generate byte imm=(citizen==2 | citizen==3);

generate byte edcode=1*(educd<=50) + 2*(educd>=60 & educd<=64)
	+ 3*(educd>=65 & educd<=90) + 4*(educd==100 | educd==101) + 5*(educd>=110);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate weeks=7.4*(wkswork2==1) + 21.3*(wkswork2==2) + 33.1*(wkswork2==3) 
	+ 42.4*(wkswork2==4) + 48.2*(wkswork2==5) + 51.9*(wkswork2==6) ;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

rename statefip state;
generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf
	(count) size=perwt, 
    by(state edcode expcode);
generate survey=2010;
sort survey state edcode expcode;

save /volumes/ddisk/data/junk07.dta, replace;

use /volumes/ddisk/data/junk60.dta;
append using /volumes/ddisk/data/junk70.dta;
append using /volumes/ddisk/data/junk80.dta;
append using /volumes/ddisk/data/junk90.dta;
append using /volumes/ddisk/data/junk00.dta;
append using /volumes/ddisk/data/junk07.dta;

sort survey state edcode expcode;

save /volumes/ddisk/immigration/programs/chapter_6/aggregate/count_state_m.dta, replace;

log close;