#delimit;
set more 1;
log using /volumes/ddisk/immigration/programs/chapter_6/aggregate/countsmsa5a.log, replace;

*USES IPUMS DOWNLOADED AT THE TIME OF JHR PAPER;

*THIS PROGRAM DOES NOT RESCALE AGE BACK TO MIDPOINT OF DECADE;

use /volumes/ddisk/ipums/ipums80.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if enroll==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd ;

generate byte imm=(citizen==2 | citizen==3);

drop if migplac5==0;
*ONLY HALF THE SAMPLE HAS INFORMATION ON RESIDENCE IN 1975;
replace perwt=perwt*2;

replace migmet5=metaread if migplac5==990;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9320;

drop if metaread0==0;
replace metaread0=int(metaread0/10);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);
generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
replace edcode=5 if (higrade>=20 & higrade<=23);
*replace edcode=5 if (educ99>=15 & educ99<=17);

generate weeks=wkswork1;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf 
	pop=perwt (count) size=weight, 
     by(metaread0 edcode expcode);
generate survey=1980;

save /volumes/ddisk/data/junk80.dta, replace;



use /volumes/ddisk/ipums/ipums90.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if school==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd;

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

replace migmet5=metaread if migplac5==0;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9360;

drop if metaread0==0;
replace metaread0=int(metaread0/10);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);
generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
*replace edcode=5 if (higrade>=20 & higrade<=23);
replace edcode=5 if (educ99>=15 & educ99<=17);

generate weeks=wkswork1;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf 
	pop=perwt (count) size=weight, 
     by(metaread0 edcode expcode);
generate survey=1990;

save /volumes/ddisk/data/junk90.dta, replace;


use /volumes/ddisk/ipums/ipums00.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if school==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd;

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

replace migmet5=metaread if migplac5==0;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9360;

drop if metaread0==0;
replace metaread0=int(metaread0/10);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);
generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
*replace edcode=5 if (higrade>=20 & higrade<=23);
replace edcode=5 if (educ99>=15 & educ99<=17);

generate weeks=wkswork1;
generate hours=uhrswork;

generate weight=perwt*weeks*hours/2000;

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

generate pimmig=imm*perwt;
generate pnative=(1-imm)*perwt;
generate nimmig=imm*perwt*(weeks>0);
generate nnative=(1-imm)*perwt*(weeks>0);
generate immiglf=imm*weight;
generate nativelf=(1-imm)*weight;

summ imm [aw=weight];
collapse (sum) pimmig pnative nimmig nnative immiglf nativelf 
	pop=perwt (count) size=weight, 
     by(metaread0 edcode expcode);
generate survey=2000;

save /volumes/ddisk/data/junk00.dta, replace;

use /volumes/ddisk/data/junk80.dta;
append using /volumes/ddisk/data/junk90.dta;
append using /volumes/ddisk/data/junk00.dta;

rename immiglf immiglf5a;
rename nativelf nativelf5a;
rename pimmig pimmig5a;
rename pnative pnative5a;
rename nnative nnative5a;
rename nimmig nimmig5a;
rename size size5a;
rename pop pop5a;
rename metaread0 metaread;

sort survey metaread edcode expcode;
save /volumes/ddisk/immigration/programs/chapter_6/aggregate/countsmsa5a.dta, replace;

log close;

