#delimit;
set more 1;
log using /volumes/ddisk/immigration/programs/chapter_6/aggregate/pmigsmsa.log, replace;

*USES IPUMS DOWNLOADED AT THE TIME OF JHR PAPER;

*FIRST I GET THE IN-MIGRATION RATE;
*PROGRAM DOES NOT RESCALE AGE IN ANY WAY;

use /volumes/ddisk/ipums/ipums80.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if enroll==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;


drop gq gqtyped sex classwkd ;

rename perwt weight;

generate byte imm=(citizen==2 | citizen==3);

drop if migplac5==0;
*ONLY HALF THE SAMPLE HAS INFORMATION ON RESIDENCE IN 1975;
replace weight=weight*2;

replace migmet5=metaread if migplac5==990;
generate metaread1=metaread;
keep if metaread1>=40 & metaread1<=9320;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9320;

drop if metaread1==0;
replace metaread1=int(metaread1/10);
drop if metaread0==0;
replace metaread0=int(metaread0/10);

generate pin=(metaread0~=metaread1);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);

generate inmig=pin*weight;

generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
replace edcode=5 if (higrade>=20 & higrade<=23);
*replace edcode=5 if (educ99>=15 & educ99<=17);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

collapse (count) sizein=weight (sum) tnat1=weight inmig, 
     by(metaread1 imm edcode expcode);
generate survey=1980;
rename metaread1 metaread;
sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/junk80.dta, replace;



use /volumes/ddisk/ipums/ipums90.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if school==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd;
rename perwt weight;

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

replace migmet5=metaread if migplac5==0;
generate metaread1=metaread;
keep if metaread1>=40 & metaread1<=9360;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9360;

drop if metaread1==0;
replace metaread1=int(metaread1/10);
drop if metaread0==0;
replace metaread0=int(metaread0/10);

generate pin=(metaread0~=metaread1);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);

generate inmig=pin*weight;

generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
*replace edcode=5 if (higrade>=20 & higrade<=23);
replace edcode=5 if (educ99>=15 & educ99<=17);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

collapse (count) sizein=weight (sum) tnat1=weight inmig, 
     by(metaread1 imm edcode expcode);
generate survey=1990;
rename metaread1 metaread;
sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/junk90.dta, replace;



use /volumes/ddisk/ipums/ipums00.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if school==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd;
rename perwt weight;

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

replace migmet5=metaread if migplac5==0;
generate metaread1=metaread;
keep if metaread1>=40 & metaread1<=9360;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9360;

drop if metaread1==0;
replace metaread1=int(metaread1/10);
drop if metaread0==0;
replace metaread0=int(metaread0/10);

generate pin=(metaread0~=metaread1);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);

generate inmig=pin*weight;

generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
*replace edcode=5 if (higrade>=20 & higrade<=23);
replace edcode=5 if (educ99>=15 & educ99<=17);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

collapse (count) sizein=weight (sum) tnat1=weight inmig, 
     by(metaread1 imm edcode expcode);
generate survey=2000;
rename metaread1 metaread;
sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/junk00.dta, replace;

use /volumes/ddisk/data/junk80.dta;
append using /volumes/ddisk/data/junk90.dta;
append using /volumes/ddisk/data/junk00.dta;

sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/pjunkin.dta, replace;


*NOW I'M GETTING THE OUT-MIGRATION RATE;





use /volumes/ddisk/ipums/ipums80.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if enroll==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd ;

rename perwt weight;

generate byte imm=(citizen==2 | citizen==3);


drop if migplac5==0;
*ONLY HALF THE SAMPLE HAS INFORMATION ON RESIDENCE IN 1975;
replace weight=weight*2;

replace migmet5=metaread if migplac5==990;
generate metaread1=metaread;
keep if metaread1>=40 & metaread1<=9320;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9320;

drop if metaread1==0;
replace metaread1=int(metaread1/10);
drop if metaread0==0;
replace metaread0=int(metaread0/10);

generate pout=(metaread0~=metaread1);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);

generate outmig=pout*weight;

generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
replace edcode=5 if (higrade>=20 & higrade<=23);
*replace edcode=5 if (educ99>=15 & educ99<=17);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

collapse (count) sizeout=weight (sum) tnat5=weight outmig, 
     by(metaread0 imm edcode expcode);
generate survey=1980;
rename metaread0 metaread;
sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/junk80.dta, replace;



use /volumes/ddisk/ipums/ipums90.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if school==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd;
rename perwt weight;

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

replace migmet5=metaread if migplac5==0;
generate metaread1=metaread;
keep if metaread1>=40 & metaread1<=9360;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9360;

drop if metaread1==0;
replace metaread1=int(metaread1/10);
drop if metaread0==0;
replace metaread0=int(metaread0/10);

generate pout=(metaread0~=metaread1);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);
generate outmig=pout*weight;

generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
*replace edcode=5 if (higrade>=20 & higrade<=23);
replace edcode=5 if (educ99>=15 & educ99<=17);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

collapse (count) sizeout=weight (sum) tnat5=weight outmig, 
     by(metaread0 imm edcode expcode);
generate survey=1990;
rename metaread0 metaread;
sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/junk90.dta, replace;



use /volumes/ddisk/ipums/ipums00.dta, clear;

keep if gq==1;
keep if age>=18 & age<=64;
keep if sex==1;
drop if school==2;
*drop if empstatd>=13 & empstatd<=15;
*keep if wkswork>0;

drop gq gqtyped sex classwkd;
rename perwt weight;

generate byte imm=(citizen==2 | citizen==3);
drop citizen;

replace migmet5=metaread if migplac5==0;
generate metaread1=metaread;
keep if metaread1>=40 & metaread1<=9360;
generate metaread0=migmet5;
keep if metaread0>=40 & metaread0<=9360;

drop if metaread1==0;
replace metaread1=int(metaread1/10);
drop if metaread0==0;
replace metaread0=int(metaread0/10);

generate pout=(metaread0~=metaread1);

*generate byte agecode=1*(age>=25 & age<=34) + 2*(age>=35 & age<=44)
     + 3*(age>=45 & age<=54) + 4*(age>=55 & age<=64);
generate byte agecode=1*(age>=25 & age<=29)
     + 2*(age>=30 & age<=34) + 3*(age>=35 & age<=39)
     + 4*(age>=40 & age<=44) + 5*(age>=45 & age<=49)
     + 6*(age>=50 & age<=54) + 7*(age>=55 & age<=59)
     + 8*(age>=60 & age<=64);
generate outmig=pout*weight;

generate byte edcode=1*(educrec<=6) + 2*(educrec==7) 
     + 3*(educrec==8) + 4*(educrec==9);
*replace edcode=5 if (higrade>=20 & higrade<=23);
replace edcode=5 if (educ99>=15 & educ99<=17);

generate exper=age-17 if edcode==1;
replace exper=age-19 if edcode==2;
replace exper=age-21 if edcode==3;
replace exper=age-23 if edcode==4;
replace exper=age-24 if edcode==5;
keep if exper>=1 & exper<=40;

generate expcode=1*(exper>=1 & exper<=5) + 2*(exper>=6 & exper<=10)
		+3*(exper>=11 & exper<=15) + 4*(exper>=16 & exper<=20)
		+5*(exper>=21 & exper<=25) + 6*(exper>=26 & exper<=30)
		+7*(exper>=31 & exper<=35) + 8*(exper>=36 & exper<=40);

collapse (count) sizeout=weight (sum) tnat5=weight outmig, 
     by(metaread0 imm edcode expcode);
generate survey=2000;
rename metaread0 metaread;
sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/junk00.dta, replace;

use /volumes/ddisk/data/junk80.dta;
append using /volumes/ddisk/data/junk90.dta;
append using /volumes/ddisk/data/junk00.dta;

sort survey metaread imm edcode expcode;
save /volumes/ddisk/data/pjunkout.dta, replace;

use /volumes/ddisk/data/pjunkin.dta, clear;
merge survey metaread imm edcode expcode using /volumes/ddisk/data/pjunkout.dta;
drop _merge;
sort survey metaread imm edcode expcode;

save /volumes/ddisk/immigration/programs/chapter_6/aggregate/pmigsmsa.dta, replace;
log close;

