#delimit;
set more 1;
clear matrix;
clear mata;
set matsize 11000;
set maxvar 11000;
log using /volumes/ddisk/immigration/programs/chapter_6/Table_6_1_smsa.log, replace;


*THE DATA SETS ARE IN THE AGGREGATE FOLDER;
*THE COUNT_SMSA_MF.DTA IS THE SAME AS THAT USED IN CHAPTER 4;

*SET 1: USING M COUNTS;

use /volumes/ddisk/immigration/programs/chapter_6/aggregate/pmigsmsa.dta, clear;
keep if imm==0;
sort survey metaread edcode expcode;
save /volumes/ddisk/data/junkmig.dta, replace;

use /volumes/ddisk/immigration/programs/chapter_6/aggregate/countsmsa5a.dta, clear;
tabulate survey;
sort survey metaread edcode expcode;
save /volumes/ddisk/data/junklag1.dta, replace;

use /volumes/ddisk/immigration/programs/chapter_6/aggregate/count_smsa_mf.dta, clear;
tabulate survey;
drop if survey<1980;
tabulate survey;
*THIS GIVES ME THE "CURRENT" COUNTS;
rename immiglf immiglf1;
rename nativelf nativelf1;
rename pimmig pimmig1;
rename pnative pnative1;
rename nnative nnative1;
rename nimmig nimmig1;
rename smsa metaread;
keep survey metaread edcode expcode immiglf1 nativelf1 pimmig1 pnative1 nnative1 nimmig1;
sort survey metaread edcode expcode;
save /volumes/ddisk/data/junklag2.dta, replace;

use /volumes/ddisk/data/junkmig.dta, clear;
merge survey metaread edcode expcode using /volumes/ddisk/data/junklag1.dta;
drop _merge;
sort survey metaread edcode expcode;
merge survey metaread edcode expcode using /volumes/ddisk/data/junklag2.dta;
drop _merge;
sort survey metaread edcode expcode;

egen totobs=sum(sizein), by(survey);
generate weight=sizein/totobs;
tabulate survey, sum(weight);
egen totobs2=sum(sizeout), by(survey);
generate weight2=sizeout/totobs2;
tabulate survey, sum(weight);

*NOTE THAT JHR PAPER ONLY INCLUDED THE 1990 AND 2000 CENSUSES;

sort survey;

*THIS CONVERTS IN- AND OUT-MIGRATION COUNTS INTO TEN-YEAR COUNTS;
replace inmig=inmig*2;
replace outmig=outmig*2;

*THE MIGRATION RATES ARE DEFINED IN TERMS OF POPULATION;
*AND THE BASE IS THE POPULATION IN THE REGION AT BEGINNING OF 5-YEAR PERIOD;
generate pin=inmig/pnative5a;
generate pout=outmig/pnative5a;
generate pnet=pin-pout;

*THE IMMIGRANT SHARES ARE DEFINED AS ALWAYS, IN TERMS OF LABOR FORCE;
generate p1=immiglf1/(immiglf1+nativelf1);
summ p1;

keep if survey>=1990 & survey<=2000;
summ p1;

tabulate edcode, gen(educ);
tabulate survey, gen(year);
tabulate expcode, gen(xp);
tabulate metaread, gen(reg);

generate skill=edcode*10 + expcode;

generate double newcode1=survey*100000 + metaread;
generate double newcode2=survey*100 + skill;
generate double newcode3=metaread*100 + skill;

tabulate newcode1, gen(c1c);
tabulate newcode2, gen(c2c);

rename metaread smsa;

generate trend=survey-1970;
generate re=smsa*10 + edcode;
generate rx=smsa*10 + expcode;

drop if pnet==. | pin==. | pout==.;

xi: areg pnet p1 c1c* c2c*,
	cluster(newcode3) absorb(newcode3);
xi: areg pin p1 c1c* c2c*,
	cluster(newcode3) absorb(newcode3);
xi: areg pout p1 c1c* c2c*,
	cluster(newcode3) absorb(newcode3);
	

log close;
