#delimit;
set more 1;
clear matrix;
clear mata;
log using /volumes/ddisk/immigration/programs/chapter_6/Table_6_1_state.log, replace;


*THE DATA SETS ARE IN THE AGGREGATE FOLDER;
*THE COUNT_STATE_Mf.DTA IS THE SAME AS THAT USED IN CHAPTER 4;

*SET 1: USING MALE COUNTS;

use /volumes/ddisk/immigration/programs/chapter_6/aggregate/pmigstate.dta, clear;
keep if imm==0;
sort survey state edcode expcode;
save /volumes/ddisk/data/junkmig.dta, replace;

use /volumes/ddisk/immigration/programs/chapter_6/aggregate/countstate5a.dta, clear;
tabulate survey;
sort survey state edcode expcode;
save /volumes/ddisk/data/junklag1.dta, replace;

use /volumes/ddisk/immigration/programs/chapter_6/aggregate/count_state_mf.dta, clear;
tabulate survey;
drop if survey<1970;
tabulate survey;
*THIS GIVES ME THE "CURRENT" COUNTS;
rename immiglf immiglf1;
rename nativelf nativelf1;
rename pimmig pimmig1;
rename pnative pnative1;
rename nnative nnative1;
rename nimmig nimmig1;
keep survey state edcode expcode immiglf1 nativelf1 pimmig1 pnative1 nnative1 nimmig1;
sort survey state edcode expcode;
save /volumes/ddisk/data/junklag2.dta, replace;

use /volumes/ddisk/data/junkmig.dta, clear;

merge survey state edcode expcode using /volumes/ddisk/data/junklag1.dta;
drop _merge;
sort survey state edcode expcode;
merge survey state edcode expcode using /volumes/ddisk/data/junklag2.dta;
drop _merge;
sort survey state edcode expcode;

egen totobs=sum(sizein), by(survey);
generate weight=sizein/totobs;
tabulate survey, sum(weight);
egen totobs2=sum(sizeout), by(survey);
generate weight2=sizeout/totobs2;
tabulate survey, sum(weight);

keep if survey>=1970 & survey<=2000;

*THIS CONVERTS IN- AND OUT-MIGRATION COUNTS INTO TEN-YEAR COUNTS;
replace inmig=inmig*2;
replace outmig=outmig*2;

*THE MIGRATION RATES ARE DEFINED IN TERMS OF POPULATION;
*AND THE BASE IS THE POPULATION IN THE REGION AT BEGINNING OF 5-YEAR PERIOD;
generate pin=inmig/pnative5a;
generate pout=outmig/pnative5a;
generate pnet=pin-pout;

*THE IMMIGRANT SHARES ARE DEFINED AS ALWAYS, IN TERMS OF LABOR FORCE;
generate p1=immiglf1/(immiglf1+nativelf1);
summ p1;

tabulate edcode, gen(educ);
tabulate survey, gen(year);
tabulate expcode, gen(xp);
tabulate state, gen(reg);

generate skill=edcode*10 + expcode;

generate double newcode1=survey*100 + state;
generate double newcode2=survey*100 + skill;
generate double newcode3=state*100 + skill;

tabulate newcode1, gen(c1c);
tabulate newcode2, gen(c2c);
tabulate newcode3, gen(c3c);

generate trend=survey-1970;
generate re=state*10 + edcode;
generate rx=state*10 + expcode;

drop if pnet==. | pin==. | pout==.;


xi: areg pnet p1 c1c* c2c*,
	cluster(newcode3) absorb(newcode3);
xi: areg pin p1 c1c* c2c*,
	cluster(newcode3) absorb(newcode3);
xi: areg pout p1 c1c* c2c*,
	cluster(newcode3) absorb(newcode3);
	

log close;
